'''
Created on 09.09.2012

@author: Admin
'''

import pygame
from pygame.locals import *
from MainGameScene import *
from Spriter import *
from UserData import *
from EndGameScene import *
from MainMenuScene import *
from SettingsScene import *

class Application:
    '''
    classdocs
    '''


    def __init__(self):
        '''
        Constructor
        '''
        self.size = (640, 480)
        self.clock = pygame.time.Clock()
        
        self.milli = 0.0
        self.seconds = 0.0#create window
        pygame.init()
        self.screen = pygame.display.set_mode(self.size,pygame.DOUBLEBUF,32)
        pygame.display.set_caption('Project "pyFrog"')
        self.windows_bgcolor = (127,127,127)
        self.mainLoop = True
        self.sceneNum = 1
        self.currentScene = None
        self.font = pygame.font.Font("fonts/font_1.ttf", 30)
        self.userData = UserData()
        self.spriter = Spriter()
        
        
        
        self.end_scene_bg = pygame.image.load("imgs/scenes_bg/endgame_bg.png").convert_alpha()
        self.main_menu_bg = pygame.image.load("imgs/scenes_bg/main_menu_bg.png").convert_alpha()
        self.settings_bg = pygame.image.load("imgs/scenes_bg/settings_bg.png").convert_alpha()
        self.game_play_bg = pygame.image.load("imgs/scenes_bg/game_play_bg.png")
        
        self.btn_continue = []
        self.btn_continue.append(pygame.image.load("imgs/buttons/continue_norm.png").convert_alpha())
        self.btn_continue.append(pygame.image.load("imgs/buttons/continue_over.png").convert_alpha())
        
        self.btn_restart = []
        self.btn_restart.append(pygame.image.load("imgs/buttons/restart_norm.png").convert_alpha())
        self.btn_restart.append(pygame.image.load("imgs/buttons/restart_over.png").convert_alpha())
        
        self.btn_play = []
        self.btn_play.append(pygame.image.load("imgs/buttons/play_norm.png").convert_alpha())
        self.btn_play.append(pygame.image.load("imgs/buttons/play_over.png").convert_alpha())
        
        self.btn_settings = []
        self.btn_settings.append(pygame.image.load("imgs/buttons/settings_norm.png").convert_alpha())
        self.btn_settings.append(pygame.image.load("imgs/buttons/settings_over.png").convert_alpha())
        
        self.btn_exit = []
        self.btn_exit.append(pygame.image.load("imgs/buttons/exit_norm.png").convert_alpha())
        self.btn_exit.append(pygame.image.load("imgs/buttons/exit_over.png").convert_alpha())
        
        self.btn_back = []
        self.btn_back.append(pygame.image.load("imgs/buttons/back_norm.png").convert_alpha())
        self.btn_back.append(pygame.image.load("imgs/buttons/back_over.png").convert_alpha())
        
        self.sound = True
        self.music = True
        
        self.wav_frog = pygame.mixer.Sound("sounds/frog.wav")
        self.wav_click = pygame.mixer.Sound("sounds/click.wav")
        self.wav_fail = pygame.mixer.Sound("sounds/fail.wav")
        self.wav_fan = pygame.mixer.Sound("sounds/fanfare.wav")
        self.wav_lose = pygame.mixer.Sound("sounds/lose.wav")
        self.wav_eat = pygame.mixer.Sound("sounds/eat.wav")
        self.wav_jump = pygame.mixer.Sound("sounds/jump.wav")
        #self.mp3_forest = pygame.mixer.Sound("sounds/forest.mp3")
        #self.mp3_forest.play()
        
        pygame.mixer.music.load("sounds/forest.mp3")
        pygame.mixer.music.play(-1)
        
        self.game_bgs = []
        self.tn = 1072 / 16
        for i in range(16):
            print self.tn * i, 0, 640 + 67, 480
            self.game_bgs.append(self.game_play_bg.subsurface(pygame.Rect(self.tn * i, 0, 640 + self.tn - 1, 480)))
            
        self.other_imgs = []
        self.other_imgs.append(pygame.image.load("imgs/other/radius.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/radius2.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/cursor.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/last_cursor.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/platform.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/finish_platform.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/frog_1.png").convert_alpha())
        self.other_imgs.append(pygame.image.load("imgs/other/frog_2.png").convert_alpha())
        
        self.collider = Collider(self.screen, self.spriter, self)
        #self.playForest()
        self.setScene(3)
        
    def getOtherImg(self, pos):
        return self.other_imgs[pos]
    
    def playSoundJump(self):
        if self.sound:
            self.wav_jump.play()
    
    def playSoundEat(self):
        if self.sound:
            self.wav_eat.play()
    
    def playSoundLose(self):
        if self.sound:
            self.wav_lose.play()
    
    def playForest(self):
        if self.music:
            self.mp3_forest.play()
    
    def playSoundFan(self):
        if self.sound:
            self.wav_fan.play()
        
    def playSoundFail(self):
        if self.sound:
            self.wav_fail.play()
        
    def playSoundFrog(self):
        if self.sound:
            self.wav_frog.play()
        
    def playSoundClick(self):
        if self.sound:
            self.wav_click.play()
        
    def switchSound(self):
        self.sound = not self.sound
        return self.sound
    
    def switchMusic(self):
        self.music = not self.music
        if self.music:
            pygame.mixer.music.play(-1)
        else:
            pygame.mixer.music.stop()
        return self.music
        
    def getSound(self):
        return self.sound
    
    def getMusic(self):
        return self.music
        
    def getButtonImage(self, btn_num,over):
        if btn_num == 1:
            return self.btn_continue[1]if over else self.btn_continue[0]
        if btn_num == 2:
            return self.btn_restart[1]if over else self.btn_restart[0]
        if btn_num == 3:
            return self.btn_play[1]if over else self.btn_play[0]
        if btn_num == 4:
            return self.btn_settings[1]if over else self.btn_settings[0]
        if btn_num == 5:
            return self.btn_exit[1]if over else self.btn_exit[0]
        if btn_num == 6:
            return self.btn_back[1]if over else self.btn_back[0]
        
    def getSceneBG(self, num):
        if num == 1:
            return self.game_bgs[self.userData.getLevel()]
        if num == 2:
            return self.end_scene_bg
        if num == 3:
            return self.main_menu_bg
        if num == 4:
            return self.settings_bg
        
    def setScene(self, numScene,restart = False):
        if restart:
            self.userData.restart()
        if numScene == 1:
            self.currentScene = MainGameScene(self, self.screen)
            return
        if numScene == 2:
            self.currentScene = EndGameScene(self, self.screen)
            return
        if numScene == 3:
            self.currentScene = MainMenuScene(self, self.screen)
        if numScene == 4:
            self.currentScene = SettingsScene(self, self.screen)
        
    def getFont(self):
        return self.font
    
    def getUser(self):
        return self.userData
    
    def main(self):
        while self.mainLoop:
            self.milli = self.clock.tick(60)
            self.seconds = self.milli / 1000.0
            
            #self.screen.fill(self.windows_bgcolor)
            self.currentScene.update()
            
            pygame.display.update()
        pygame.quit()