'''
Created on 09.09.2012

@author: Admin
'''
import math
import pygame
from pygame.locals import *
from Frog import *
from Collider import *
import user



class MainGameScene():
    '''
    classdocs
    '''


    def __init__(self, game, py_screen):
        '''
        Constructor
        '''
        self.ws = game
        self.spriter = game.spriter
        self.screen = py_screen
        self.frog = Frog(self, self.screen, self.ws)
        self.state = 1
        self.collider = self.ws.collider
        self.collider.updateRectPos()
        self.radius = 120
        self.power = [0,0]
        self.tracks = []
        self.t_c = 100
        for i in range(self.t_c):
            self.tracks.append([0,0])
            #print i
        
        self.platform = pygame.Rect(0,0,100,10)
        self.platform.center = self.collider.getStart()
        self.last_pos = [self.platform.x, self.platform.y]
        self.platform_start= self.collider.getStart()
        

        self.p_dx = 0
        self.p_dy = 0
        
        self.pp_x = self.platform.x -self.frog.getRect().x
        self.pp_y = self.platform.y -self.frog.getRect().y
        
        self.tweenSec = 0.0
        
        self.life_bg = pygame.image.load("imgs/life_bg.png").convert_alpha()
        self.life_bg_pos = (0,0)
        
        self.life_count_surf = None
        self.life_count_surf_bg = None
        self.life_count_color = (255,51,0)
        self.life_count_pos = (50,10)
        self.life_count_color_bg = (102,102,102)
        self.life_count_pos_bg = (52,12)
        
        
        self.points_bg = pygame.image.load("imgs/points_bg.png").convert_alpha()
        self.points_bg_pos = (122,11)
        
        self.point_count_surf = None
        self.point_count_surf_bg = None
        self.point_count_pos = (155,10)
        self.point_count_pos_bg = (157,12)
        
        self.gui_1_bg = pygame.image.load("imgs/gui.png").convert_alpha()
        self.gui_1_bg_pos = (0,0)
        
        self.updateLifeCount()
        self.updatePointsCount()
        
        self.bg_move = self.ws.getSceneBG(1)
        
        self.bg_rect = pygame.Rect(0,0,640,480)
        self.bg = self.bg_move.subsurface(self.bg_rect)
        print self.bg.get_width()
        self.bg_pos = [0,0]
        self.bg_x = 0
        
        self.img_rad_1 = self.ws.getOtherImg(0)
        self.img_rad_2 = self.ws.getOtherImg(1)
        self.rad_num = True
        
        self.pos_rad_1 = [0,0]
        self.pos_rad_2 = [0,0]
        self.lpc = None
        
        self.cp = [0,0]
        self.cursor = self.ws.getOtherImg(2)
        self.lcursor = self.ws.getOtherImg(3)
        
        self.platform_img = self.ws.getOtherImg(4)
        
        
        self.setState1()
        
    def drawUI(self):
        self.screen.blit(self.gui_1_bg, self.gui_1_bg_pos)
        self.screen.blit(self.life_count_surf_bg, self.life_count_pos_bg)
        self.screen.blit(self.life_count_surf, self.life_count_pos)
        
        self.screen.blit(self.point_count_surf_bg, self.point_count_pos_bg)
        self.screen.blit(self.point_count_surf, self.point_count_pos)
        
        
        
        
        
    def updateLifeCount(self):
        font = self.ws.getFont()
        user = self.ws.getUser()
        lifes = user.getLife()
        if lifes < 10:
            s = "0"+str(lifes)
        else:
            s = str(lifes)
        self.life_count_surf = font.render(s, True, self.life_count_color,)
        self.life_count_surf_bg = font.render(s, True, self.life_count_color_bg,)
        
    def updatePointsCount(self):
        font = self.ws.getFont()
        user = self.ws.getUser()
       
        points = user.getPoints()
        if points < 10:
            s = "00"+str(points)
        else:
            if points < 100:
                s = "0"+str(points)
            else:
                s = str(points)
        self.point_count_surf = font.render(s, True, self.life_count_color,)
        self.point_count_surf_bg = font.render(s, True, self.life_count_color_bg,)
        
            
    def drawTrack(self, power, recal):
        if recal:
            start_p = self.frog.getFrogPos()
            pwr = [0,0]
            pwr[0] = power[0]
            pwr[1] = power[1]
            
            
            self.tracks[0] = [start_p[0], start_p[1]]
            for i in range(self.t_c - 1):
                pos_a = self.tracks[i]
                pos_b = self.tracks[i+1]
                pos_b[0] = pos_a[0] + pwr[0] * 0.017
                pos_b[1] = pos_a[1] + pwr[1] * 0.017
                pwr[1] += 200 * self.ws.seconds
            
        #print self.tracks
        pygame.draw.lines(self.screen, (255,255,255), False, self.tracks)
        
    def isCollide(self, rect):
        return self.collider.isCollide(rect)
    
    def isCollideBees(self, rect):
        return self.collider.isCollideBees(rect)
    
    def isCollidePoints(self, rect):
        if self.collider.isCollidePoints(rect):
            self.ws.getUser().addPoint()
            self.updatePointsCount()
            self.ws.playSoundEat()
            return True
        return False
    
    def setState1(self, dead = False):
        self.platform_start = self.collider.getStart()
        self.bg_pos[0] = 0
        self.bg = self.ws.getSceneBG(1)
        if dead:
            self.ws.playSoundFail()
            user = self.ws.getUser()
            if user.removeLife():
                self.ws.playSoundLose()
                self.ws.setScene(2)
                return
            self.updateLifeCount()
            
        else:
            self.collider.updatePoints()
            self.lpc = None
        self.state = 1
        self.platform.center = self.platform_start
        self.last_pos[0] = self.platform.x - self.pp_x
        self.last_pos[1] = self.platform.y - self.pp_y
        
        self.frog.setFrogPos(self.last_pos)
        
        self.pos_rad_1[0] = self.frog.getFrogPos()[0]
        self.pos_rad_1[1] = self.frog.getFrogPos()[1] - 120
        
        
        
        self.pos_rad_2[0] = self.frog.getFrogPos()[0] - 120
        self.pos_rad_2[1] = self.frog.getFrogPos()[1] - 120
        
        
        
        
        
    
    def setState3(self):
        if self.ws.getUser().addLevel():
            self.ws.playSoundFan()
            self.ws.setScene(2)
            return
        self.state = 3
        self.platform_start = self.collider.getStart()
        rect = self.collider.getPlatform()
        p_rect = self.frog.getRect()
        p_rect.y = rect.y - p_rect.height
        self.p_dx =rect.centerx - self.platform_start[0]
        self.p_dy =rect.centery - self.platform_start[1]
        self.platform = rect.copy()
        self.tweenSec = 1.0
        
        self.pp_x = self.platform.x - p_rect.x
        self.pp_y = self.platform.y - p_rect.y
        self.bg_x = 0
        
        
        
    
        
    def update(self):
        
        
        for event in pygame.event.get():
            if event.type == QUIT:
                self.ws.mainLoop = False
            if event.type == MOUSEBUTTONDOWN:
                if event.button == 1:
                    if self.state == 1:
                        self.lpc = [0,0]
                        self.lpc[0] = self.cp[0]
                        self.lpc[1] = self.cp[1]
                        self.ws.playSoundFrog()
                        self.state = 2;
                        self.frog.addPower(self.power)
        self.screen.blit(self.bg, self.bg_pos)
        if self.state == 1:
            self.frog.update1()
            start_pos = self.frog.getFrogPos()
            
            end_pos = pygame.mouse.get_pos()
            
            self.rad_num = start_pos[0] < end_pos[0]
            
            if end_pos[1] > start_pos[1]:
                end_pos = (end_pos[0], start_pos[1])
                
            vec_len = math.sqrt(start_pos[0]*start_pos[1]+end_pos[1]*end_pos[1])
            
            
            vec_dx = end_pos[0] - start_pos[0]
            vec_dy = end_pos[1] - start_pos[1]
            vec_len = math.sqrt(vec_dx*vec_dx+vec_dy*vec_dy)
            if vec_len > self.radius:
                vec_len = self.radius;

            rad = math.atan2(vec_dy, vec_dx)
            
            vec_norm = vec_len / self.radius
            
            t_sin = math.cos(rad) * 400 * vec_norm
            t_cos = math.sin(rad) * 400 * vec_norm
            
            px = int((math.cos(rad)*vec_len))
            py = int((math.sin(rad)*vec_len))
            
            self.power[0] = t_sin
            self.power[1] = t_cos
            
            
            pos = (px + start_pos[0], py+start_pos[1])
            
            #pygame.draw.circle(self.screen, (255,255,0), pos, 10)
            if self.rad_num:
                self.screen.blit(self.img_rad_1, self.pos_rad_1)
            else:
                self.screen.blit(self.img_rad_2, self.pos_rad_2)
            
            #pygame.draw.line(self.screen, (255,255,128), start_pos, end_pos)
            #self.drawTrack(self.power, True)
            self.cp[0] = pos[0] - 10
            self.cp[1] = pos[1] - 10
            
            self.screen.blit(self.cursor, self.cp)
            if self.lpc:
                self.screen.blit(self.lcursor, self.lpc)
            
            
            #pygame.draw.rect(self.screen, (0,255,0), self.platform)
            self.screen.blit(self.platform_img, self.platform.topleft)
            self.collider.draw(self.ws.seconds)
        else: 
            if self.state == 2:
                self.screen.blit(self.platform_img, self.platform.topleft)
                self.collider.draw(self.ws.seconds)
                self.frog.update2()
                
                
            else:
                if self.state == 3:
                    self.screen.blit(self.platform_img, self.platform.topleft)
                    self.tweenSec -= self.ws.seconds
                    self.platform.centerx = self.platform_start[0] + (self.tweenSec * self.p_dx)
                    self.platform.centery = self.platform_start[1] + (self.tweenSec * self.p_dy)
                    self.frog.getRect().x = self.platform.x - self.pp_x
                    self.frog.getRect().y = self.platform.y - self.pp_y
                    self.frog.update3()
                    self.bg_x -= self.ws.seconds * 67
                    self.bg_pos[0] = int(self.bg_x)
                    if self.tweenSec <= 0.0:
                        self.collider.updateRectPos()
                        self.setState1()
        
        
        #self.drawTrack(self.power, False)
        self.drawUI()