'''
Created on 13.09.2012

@author: Admin
'''
import pygame
from pygame.locals import *

class MainMenuScene:
    '''
    classdocs
    '''


    def __init__(self, game, py_screen):
        '''
        Constructor
        '''
        self.ws = game
        self.screen = py_screen
        self.bg = self.ws.getSceneBG(3)
        self.spriter = self.ws.spriter
        
        self.play_over = False
        self.settings_over = False
        self.exit_over = False
        
        self.play_roll = False
        self.settings_roll = False
        self.exit_roll = False
        
        self.btn_play_over = self.ws.getButtonImage(3, True)
        self.btn_play_norm = self.ws.getButtonImage(3, False)
        
        self.btn_settings_over = self.ws.getButtonImage(4, True)
        self.btn_settings_norm = self.ws.getButtonImage(4, False)
        
        self.btn_exit_over = self.ws.getButtonImage(5, True)
        self.btn_exit_norm = self.ws.getButtonImage(5, False)
        
        self.img = None
        
        self.rect_play =        pygame.Rect(239, 254, 162, 52)
        self.rect_settings =    pygame.Rect(239, 314, 162, 52)
        self.rect_exit =        pygame.Rect(239, 374, 162, 52)
        
        self.bee_pos = [-42,148]
        self.bee_x = -42;
        
        
        
    def update(self):
        mouse_pos = pygame.mouse.get_pos()
        
        self.play_over = self.rect_play.collidepoint(mouse_pos)
        self.settings_over = self.rect_settings.collidepoint(mouse_pos)
        self.exit_over = self.rect_exit.collidepoint(mouse_pos)
        
        
        
        if self.play_over:
            if not self.play_roll:
                self.play_roll = True
                self.ws.playSoundClick()
        self.play_roll = self.play_over
        
        if self.settings_over:
            if not self.settings_roll:
                self.settings_roll = True
                self.ws.playSoundClick()
        self.settings_roll = self.settings_over
        
        if self.exit_over:
            if not self.exit_roll:
                self.exit_roll = True
                self.ws.playSoundClick()
        self.exit_roll = self.exit_over
        
        for event in pygame.event.get():
            if event.type == QUIT:
                self.ws.mainLoop = False
            if event.type == MOUSEBUTTONDOWN:
                if self.rect_play.collidepoint(mouse_pos):
                    self.ws.playSoundFrog()
                    self.ws.setScene(1, True)
                else:
                    if self.rect_settings.collidepoint(mouse_pos):
                        self.ws.playSoundFrog()
                        self.ws.setScene(4)
                    else:
                        if self.rect_exit.collidepoint(mouse_pos):
                            self.ws.playSoundFrog()
                            self.ws.mainLoop = False
        
        self.screen.blit(self.bg, (0,0))
        
        self.img = self.btn_play_over if self.play_over else self.btn_play_norm
        self.screen.blit(self.img, self.rect_play.topleft)
        
        self.img = self.btn_settings_over if self.settings_over else self.btn_settings_norm
        self.screen.blit(self.img, self.rect_settings.topleft)
        
        self.img = self.btn_exit_over if self.exit_over else self.btn_exit_norm
        self.screen.blit(self.img, self.rect_exit.topleft)
        
        self.spriter.addFlyTime(self.ws.seconds)
        self.spriter.addBeeTime(self.ws.seconds)
        self.img = self.spriter.getCurrentFrameFly()
        self.screen.blit(self.img, (117,300))
        self.screen.blit(self.img, (526,404))
        self.screen.blit(self.img, (453,222))
        
        self.bee_x += self.ws.seconds * 60
        
        if self.bee_x > 700:
            self.bee_x = - 42
        self.bee_pos[0] = int(self.bee_x)
        
        
        self.img = self.spriter.getCurrentFrameBee(True)
        self.screen.blit(self.img, self.bee_pos)